﻿using Microsoft.AspNetCore.Components;
using VeraxShield.composants.formulaires.modeles;
using VeraxShield.factories;
using VeraxShield.modele.utilisateurs;
using VeraxShield.services.UtilisateursDataService;

namespace VeraxShield.composants.formulaires
{
    public partial class FormulaireAjout
    {
        [Inject]
        private NavigationManager NavigationManager { get; set; }

        private FormulaireAjoutModele Modele { get; set; }

        [Inject]
        private IUtilisateursDataService utilisateursDataService { get; set; }

        public FormulaireAjout()
        {

        }

        protected override async Task OnInitializedAsync()
        {
            this.Modele = new FormulaireAjoutModele();
            this.Modele.IsBan = false;
            await base.OnInitializedAsync();
        }

        protected override Task OnAfterRenderAsync(bool firstRender)
        {
            //// [Temporaire] : Pour mettre au propre le localstorage à chaque essai
            //if (firstRender)
            //{
            //    this.utilisateursDataService.resetDataUtilisateurs();
            //}

            return base.OnAfterRenderAsync(firstRender);
        }

        public async void ajouterUtilisateur()
        {
            List<Utilisateur> data = await this.utilisateursDataService.getAllUtilisateurs();

            Utilisateur nouvelUtilisateur = UtilisateursFactory.toUtilisateur(this.Modele);
            data.Add(nouvelUtilisateur);
            await this.utilisateursDataService.SaveAllUtilisateurs(data);

            Console.WriteLine("Utilisateur bien ajouté !");
            this.NavigationManager.NavigateTo("/utilisateurs/liste");
        }
    }
}
